<?php

/**
 * My Youtube - A plugin that provide a custom button on editor toolbar 
 * to embed video from Youtube. Depends on Toolbar Container plugin for
 * displaying the button.
 *  
 * License: New BSD License (http://www.rioastamal.net/mybb/LICENSE.txt)
 */

// Disallow direct access to this file for security reasons
if(!defined("IN_MYBB")) {
   die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}

// register some hooks
$plugins->add_hook('toolbar_container_collect', 'my_youtube_collect');
$plugins->add_hook("parse_message", "my_youtube_parse_message");

/**
 * Function which describe plugin information
 *
 * @return array
 */
function my_youtube_info() {
   return array(
      "name"            => "My Youtube",
      "description"     => "A plugin that add custom button on editor toolbar to embed youtube video into a post",
      "website"         => "http://rioastamal.net/mybb/my-youtube/",
      "author"          => "Rio Astamal",
      "authorsite"      => "http://rioastamal.net/",
      "version"         => "1.3",
      "guid"            => "00ae12ac5a32288a6f791a4b675288d1", 
      "compatibility"   => "14*"
   );
}

function my_youtube_activate() { 
}

function my_youtube_deactivate() { 
}

/*
 * Function to parse the [my-youtube] BBCoide and replace it with 
 * <object> and <embed> tag
 * 
 * @param string $post_message
 * @return void
 */
function my_youtube_parse_message($post_message) {
   $replacement = '<object width="$1" height="$2"><param name="movie" value="http://www.youtube.com/v/$4&hl=en&fs=1"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="http://www.youtube.com/v/$4&hl=en&fs=1" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="$1" height="$2"></embed></object>';
   $pattern = "#\[my\-youtube\s+width=(.*?)\s+height=(.*?)\]http://(www\.)?youtube.com/watch\?v=(.*?)\[/my\-youtube\]#i";
   
   $post_message = preg_replace($pattern, $replacement, $post_message);
}

function my_youtube_collect(&$ic) {
   $callback = "
                  var ask_loc = prompt('Enter the youtube URL\\ne.g http://www.youtube.com/watch?v=xxxxxx', '');
                  if (ask_loc == null) return;
                  clickableEditor.performInsert('[my-youtube width=425 height=344]' + ask_loc + '[/my-youtube]', '', true, false);
               ";
   $toolbar = array(
      'id'     => 'my_youtube_v12',
      'name'   => 'my_youtube',
      'image'  => 'youtube-logo.png',
      'callback' => $callback,
      'title'  => 'Embed video from Youtube'
   );
   $ic->collect_item($toolbar);
}
?>
